﻿using System;
using Wisej.Web;
using System.Collections.Generic;
using System.Linq;
using System.ComponentModel;

namespace DataRepeaterExample
{
    public partial class MainPage : Page
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void MainPage_Load(object sender, EventArgs e)
        {
            cbRole.DataSource = RoleList;
            tbID.DataBindings.Add("Text", employeeList, "ID");
            tbName.DataBindings.Add("Text", employeeList, "Name");
            cbRole.DataBindings.Add("SelectedValue", employeeList, "Role");
            DataRepeater1.DataSource = employeeList;
        }

        private void btnUp_Click(object sender, EventArgs e)
        {
            var nCurr = DataRepeater1.CurrentItemIndex;
            int nAbve = nCurr - 1;
            var l = employeeList;
            var t = l[nCurr];
            l[nCurr] = l[nAbve];
            l[nAbve] = t;
        }

        private void btnDown_Click(object sender, EventArgs e)
        {
            var nCurr = DataRepeater1.CurrentItemIndex;
            int nBelow = nCurr + 1;
            var l = employeeList;
            var t = l[nCurr];
            l[nCurr] = l[nBelow];
            l[nBelow] = t;
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            var nCurrIdx = DataRepeater1.CurrentItemIndex;
            DataRepeater1.RemoveAt(nCurrIdx);
        }

        private void DataRepeater1_ItemUpdate(object sender, DataRepeaterItemEventArgs e)
        {
            var oDpi = e.DataRepeaterItem;
            int nIdx = oDpi.ItemIndex + 1;
            var gb = oDpi.Controls.OfType<GroupBox>().First();
            gb.Text = string.Format("Section {0}", nIdx);
            var btnUp = gb.Controls.OfType<Button>().First(x => x.Name == "btnUp");
            var btnDown = gb.Controls.OfType<Button>().First(x => x.Name == "btnDown");
            btnUp.Enabled = oDpi.ItemIndex != 0;
            btnDown.Enabled = oDpi.ItemIndex != (employeeList.Count - 1);
        }

        private BindingList<Employee> employeeList = new BindingList<Employee>(){
            new Employee(1, "Alice", "CEO"),
            new Employee(2, "Bob",   "Manager"),
            new Employee(3, "Chris", "Staff"),
            new Employee(4, "Donald", "Manager"),
            new Employee(5, "Emily", "Staff"),
            new Employee(6, "Frank", "Staff"),
            new Employee(7, "Jack", "Staff"),
            new Employee(8, "John", "Staff")
            };

        public class Employee
        {
            public Employee(int nID, string sName, string sRole)
            {
                ID = nID;
                Name = sName;
                Role = sRole;
            }
            public int ID { get; set; }
            public string Name { get; set; }
            public string Role { get; set; }
        }

        private List<Role> RoleList = new List<Role>() {
            new Role("CEO", "CEO"),
            new Role("Manager", "Manager"),
            new Role("Staff", "Staff")
        };

        public class Role
        {
            public Role(string sCode, string sName)
            {
                Code = sCode;
                Name = sName;
            }
            public string Code { get; set; }
            public string Name { get; set; }
        }

        private void DataRepeater1_ItemSelected(object sender, DataRepeaterItemEventArgs e)
        {
            var oDpi = e.DataRepeaterItem;
            var gb = oDpi.Controls.OfType<GroupBox>().First();
            var tbID = gb.Controls.First(x => x.Name == "tbID");
            var tbName = gb.Controls.First(x => x.Name == "tbName");
            var cbRole = (ComboBox)gb.Controls.First(x => x.Name == "cbRole");
            lbSelectedIDText.Text = tbID.Text;
            lbSelectedNameText.Text = tbName.Text;
            lbSelectedRoleText.Text = (string)cbRole.SelectedValue;
        }
    }
}
